﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using icon_cs;

namespace iicon
{
	public class FileInfoWindow : Window
	{
		Image _image;
		TextBlock[] _texts;

		public FileInfoWindow()
		{
			this.Title = "Get FileInfo";
			this.Drop += new DragEventHandler(OnDrop);
			this.AllowDrop = true;
			this.SizeToContent = SizeToContent.WidthAndHeight;
			this.ResizeMode = ResizeMode.NoResize;
			// Controls
			var panel = new StackPanel();
			this.Content = panel;
			var b = new TextBlock(new Bold(new Run("Get FileInfo as Droped File")));
			panel.Children.Add(b);
			_image = new Image();
			_image.Height = _image.Width = 32;
			panel.Children.Add(_image);
			// Create TextBlock List
			_texts = new TextBlock[4];
			for (int i=0; i<4; i++)
			{
				TextBlock tb = new TextBlock();
				panel.Children.Add(tb);
				_texts.SetValue(tb, i);
			}
		}

		void OnDrop(object sender, DragEventArgs e)
		{
			var filenames = (string[])e.Data.GetData(DataFormats.FileDrop);
			var item = new CItem();
			if (Win32FileInfo.GetFileInfo(filenames[0], ref item))
			{
				// GetSystem.IO.FileInfo
				var ioinfo = new System.IO.FileInfo(filenames[0]);
				// icon
				_image.Source = item.image;
				// FileName
				_texts[0].Text = item.name;
				// Updated
				_texts[1].Text = ioinfo.LastWriteTime.ToString("yyyy/MM/dd HH:mm");
				// Type Name
				_texts[2].Text = item.type;
				// File Size
				_texts[3].Text = Math.Ceiling(ioinfo.Length / 1024.0).ToString("#,##0 KB");
			}
		}

		[STAThread]
		public static void Main()
		{
			var app = new Application();
			app.Run(new FileInfoWindow());
		}
	}
}
